<template>
<div id="email-form"
class="form-wrapper">
  <div v-if="!isEmailSaved">
    <h2>Join the private beta.</h2>
    <div class="text">
      <p>
        Leave your email here to get notified once the private beta is ready
        <!-- If you'd like us to <b>send you a reminder when the private beta is ready</b>
        just <b>leave your email here</b>. -->
      </p>
    </div>
  </div>
  <div v-else>
    <h2>You're on the list!</h2>
    <div class="text">
      <p>
        While you wait, check out our
        <a class="twitter-link"
        href="https://www.twitter.com/coinpaste"
        target="blank">
          Twitter.
        </a>
      </p>
    </div>
  </div>

  <div v-if="!isEmailSaved">
    <form class="email-form"
    @submit="onEmailFormSubmit">
      <app-input id="landing-page-email"
      v-model="email"
      :type="'email'"
      :placeholder="'Enter email address'"/>


      <app-button v-if="!isLoading"
      class="button-item"
      :buttonType="'floating'"
      :buttonValue="'Notify Me'"/>
      <font-awesome-icon v-else
      :icon="iconSpinner"
      size="lg"
      spin/>
    </form>
  </div>
  <!-- <div v-else>
    <b>Email Saved!</b>
  </div> -->
  <div class="error"
  v-for="(error, index) in errors"
  :key="index"
  :text="error">
    <b>{{ error }}</b>
  </div>
</div>
</template>

<script>
import EmailService from '@/mixins/EmailService';

import AppInput from '@/components/AppInput';
import AppButton from '@/components/AppButton';
import FontAwesomeIcon from '@fortawesome/vue-fontawesome';

import faSpinner from '@fortawesome/fontawesome-free-solid/faSpinner';

export default {
  name: 'LandingPageEmailForm',
  mixins: [EmailService],
  components: {
    AppInput,
    AppButton,
    FontAwesomeIcon,
  },
  data() {
    return {
      email: '',
      isLoading: false,
      isEmailSaved: false,
      errors: [],
    };
  },
  computed: {
    iconSpinner() {
      return faSpinner;
    },
  },
  methods: {
    async onEmailFormSubmit(e) {
      e.preventDefault();

      // Write email into firestore DB
      if (this.email && !this.isLoading) {
        this.errors = [];
        this.isLoading = true;
        try {
          await this.writeEmailToDb(this.email);
          this.isLoading = false;
          this.isEmailSaved = true;
          this.email = '';
        } catch (error) {
          this.isLoading = false;
          this.errors.push(error.message);
        }
      }
    },
  },
};
</script>

<style lang='scss' scoped>
@import '~styles/colors.scss';

.form-wrapper {
  margin: 0;
  padding: 2em 1em;
  min-height: 229px;

  background: linear-gradient(135deg, $gradient-left 0%,$gradient-right 100%);

  color: $text-secondary;
}

.text {
  max-width: 650px;
  margin: auto;

  font-weight: bold;
  font-size: 1.2em;
  text-align: center;

  .twitter-link {
    color: white;
  }
}

.email-form {
  display: flex;
  justify-content: center;
  align-items: center;
}

.error {
  color: red;
}

@media screen and (max-width: 768px){
  .email-form {
    flex-direction: column;
  }
}
</style>
